/* dbfncs.h header file for dbfncs.c */
/* markus@mhoenicka.de 2002-08-06 */
/* $Id: dbfncs.h,v 1.6 2003/10/25 23:50:51 mhoenicka Exp $ */

/*
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

struct db_caps {
  char multiple_db[2]; /* if t, SELECT can address tables in more than
			  one db */
  char sql_enum[2]; /* if t, the db engine supports an enum type */
  char rlike[6]; /* what SELECT uses to implement a regexp like */
  char not_rlike[10]; /* what SELECT uses to implement a regexp not like */
  char transaction[2]; /* if t, the db engine supports transactions */
  char localhost[10]; /* the string used to access the db engine on
			 localhost */
  char encoding[2]; /* if t, db engine supports different char encodings */
  char groups[3]; /* if t, db engine uses groups to manage users */
  char admin_systable[11]; /* a table that only the admin may access */
  char listall[3]; /* the string used in SELECT to list all entries */
  char bigint[2]; /* if t, db engine supports unsigned long long */
  char sql_union[2]; /* if t, the db engine supports UNION in SELECT */
  int has_versioninfo; /* if non-zero, struct was updated with db
			  engine version-specific information */
};

struct db_caps* new_db_caps(struct CLIENT_REQUEST* ptr_clrequest);
void free_db_caps(struct db_caps* ptr_caps);
int create_tables_mysql(dbi_conn conn, struct CLIENT_REQUEST* ptr_clrequest);
int create_tables_pgsql(dbi_conn conn, struct CLIENT_REQUEST* ptr_clrequest);
int create_tables_sqlite(dbi_conn conn, struct CLIENT_REQUEST* ptr_clrequest);
int is_user_pgsql(dbi_conn conn, const char* username);
int is_group_pgsql(dbi_conn conn, const char* groupname);
const char* my_dbi_driver_regexp(dbi_driver driver, int like);
int my_dbi_conn_begin(dbi_conn conn);
int my_dbi_conn_rollback(dbi_conn conn);
int my_dbi_conn_commit(dbi_conn conn);
int my_dbi_conn_lock(dbi_conn conn);
int my_dbi_conn_lock_note(dbi_conn conn);
int my_dbi_conn_unlock(dbi_conn conn);
const char* my_dbi_conn_get_cap(dbi_conn conn, const char* cap);
const char* my_dbi_driver_get_cap(dbi_driver driver, const char* cap);
unsigned long long my_dbi_result_get_idval(dbi_result dbires, const char* fieldname);
unsigned long long my_dbi_result_get_idval_idx(dbi_result dbires, unsigned long long idx);
int my_dbi_conn_get_versioninfo(dbi_conn conn, struct VERSIONINFO* ptr_ver);




