/* refdb.h main include file for the refdb project */
/* markus@mhoenicka.de 2-10-00 */
/* $Id: refdb.h,v 1.14 2004/01/31 14:50:22 mhoenicka Exp $ */

/*
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

#define REFDB_PROTOCOL_VERSION 2 /* version of the client-server dialog protocol */
#define COMMAND_INBUF_LEN 4096 /* length of buffer for client -> server */
#define OUTBUF_LEN 4096 /* length of buffer for server -> client */
#define MAX_FMT_LEN 256 /* maximum length of a getref format string, including the terminating \0 */
#define DBNAME_LENGTH 32 /* maximum database name length (imposed by MySQL) */
#define PRIV_LENGTH 16 /* maximum length of a privilege name in MySQL security
			  tables */
#define PASSWD_LENGTH 16 /* this appears to be the maximum length of a MySQL
			    password */
#define DBUSER_LENGTH 16 /* the maximum database user name length */
#define XMLPARSE_CHUNKSIZE 4096 /* the chunk size when reading an XML file */
#define PROTOCOL_LENGTH 16 /* maximum length of protocol identifier string */

/* this accommodates a variable name of max. 16 chars, a tab,
   a POSIX full path, and a \0 (273 = _POSIX_PATH_MAX + 18)*/
#define PREFS_BUF_LEN 273

#ifndef __CYGWIN__
#  if !defined _POSIX_PATH_MAX
#    define _POSIX_PATH_MAX 256 
#  endif
#endif

/* define a few things that should be accessible through libdbi */
#define USERNAME_LENGTH 16
#define HOSTNAME_LENGTH 64

struct BSTRING {
  char text[64]; /* the text of the string (up to 63 char + \0) */
  int length; /* the length of the string */
};

/* the length of the poly-\0 sequence used to terminate a
   client/server message */
#define TERM_LEN 4

/* whether or not to terminate a client/server message */
#define TERM_YES 1
#define TERM_NO 0
